#pragma once
#include <windows.h>
#include <unknwn.h>

const WORD EXT_TYPE_TRANSPORT = 0x0001;
const WORD EXT_TYPE_PLUGIN = 0x0002;

//plugin extension parameters
struct TExtParamsPG 
{
    bool	ListenTextMsgs;
};

struct TExtensionInfo
{
	WORD			ExtType;
    BYTE			ExtUUID[16];
    BSTR			ExtName; //must not be empty
    BSTR			ExtVer;
    BSTR			ExtAuthor;
    BSTR			ExtInfoURL;
    TExtParamsPG*	ExtParams;    //according ExtType
    bool			ExtTimer;    //extensions wants to receive timer ticks for instances, every ~100 msecs will be called TimerTick function  
};

struct TExtServerInfo
{
    WORD	VerMajor;
    WORD	VerMinor;
    WORD	VerRelease;
    WORD	VerBuild;
    BSTR	PathUserDB;
    BSTR	PathLogFiles;  
};

struct TExtPlugTextMsg
{
    BSTR	AccSender;
    BSTR	AccRcver;
    DWORD	MsgType;
    BSTR	MsgText;
    bool	AckRequired;    //delivery report from receiver required
    bool	MsgEncrypted;    //if message is encrypted then it will be base64 encoded, but anyway it can't be decryted
    bool	SystemMsg;    //system message flag
    BYTE	SystemMsgPos;       //system message popup position (0 - default, 1 - screen center)
    bool	MultipleMsg;    //multiple message flag
    bool	RcverOffline;    //receiver is offline at message sending moment
    BSTR	TranspOwnerAcc; //transport owner account name if message was send to transport
	BSTR	TranspUUIDHex; //transport UUID in hex if message was send to transport
};

//plugin extension interface
class IExtensionPG:	public IUnknown
	{
	public:
		virtual void __stdcall TimerTick() = 0;
		virtual void __stdcall NotifyTextMsg(const TExtPlugTextMsg* ExtPlugTextMsg) = 0;
	};

//plugin events interface
class IEventsPG: public IUnknown
	{
	public:  
		virtual void __stdcall GetServerInfo(TExtServerInfo* ServerInfo) = 0;
};

