#include <stdio.h>
#include <windows.h>

#include "u_ext_info.h"

TExtensionInfo ExtInfo = {0};
TExtParamsPG ExtParams = {0};

class TTestPlugin : public IExtensionPG
{	
private:	
		ULONG		PlugCntr;
		IEventsPG*	EventsPG;
public:		
		ULONG		__stdcall	AddRef();
		HRESULT		__stdcall	QueryInterface(REFIID riid, void** ppvObject);
		ULONG		__stdcall	Release();

		TTestPlugin(IEventsPG* AEventsPG);	
		~TTestPlugin();

		void		__stdcall TimerTick();
		void		__stdcall NotifyTextMsg(const TExtPlugTextMsg* ExtPlugTextMsg);
};

ULONG	__stdcall	TTestPlugin::AddRef()	{return ++PlugCntr;}
HRESULT	__stdcall	TTestPlugin::QueryInterface(REFIID riid, void** ppvObject)	{return E_FAIL;}
ULONG	__stdcall	TTestPlugin::Release()	{return --PlugCntr;}

TTestPlugin:: TTestPlugin(IEventsPG* AEventsPG):PlugCntr(0){EventsPG = AEventsPG;}
TTestPlugin::~TTestPlugin(){}


void __stdcall TTestPlugin::TimerTick()
{

}

void __stdcall TTestPlugin::NotifyTextMsg(const TExtPlugTextMsg* ExtPlugTextMsg)
{
  TExtServerInfo ServerInfo = {0};
  
  EventsPG->GetServerInfo( &ServerInfo );

  OutputDebugString(ServerInfo.PathLogFiles);
}

#include "u_test_plug.h"